Option Explicit

Type HotSpotRecords
    Image As String * 128
    Target As String * 128
    TopX As Integer
    TopY As Integer
    BottomX As Integer
    BottomY As Integer
    End Type

Global Const ImageLinkFile = 1
Global HotSpotRecord As HotSpotRecords
Global hRectRgn As Integer
Global CurrentImageFilename As String
Global CurrentHotspotRecordNumber As Long
Global AnchorX As Integer
Global AnchorY As Integer
Global EndX As Integer
Global EndY As Integer


Declare Function CreateRectRgn Lib "GDI" (ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
Declare Function PtInRegion Lib "GDI" (ByVal hRgn As Integer, ByVal X As Integer, ByVal Y As Integer) As Integer
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer

Declare Function mciExecute Lib "MMSystem" (ByVal CommandString As String) As Integer

Sub DeleteRegion (hRgn As Integer)
    If hRgn <> 0 Then
        If DeleteObject(hRgn) Then
            hRgn = 0
          Else
            MsgBox "Unable to Delete Region", 48, "GDI Error"
          End If
      End If
    End Sub

Sub InitRecordBuffer ()
    HotSpotRecord.Image = ""
    HotSpotRecord.Target = ""
    HotSpotRecord.TopX = 0
    HotSpotRecord.TopY = 0
    HotSpotRecord.BottomX = 0
    HotSpotRecord.BottomY = 0
    End Sub

Sub SaveHotspotRecord (HotSpotRecord As HotSpotRecords, RecordPos As Long)
    Dim Counter As Long
    Dim FileSize As Long
    Dim TempRecord As HotSpotRecords
    Dim BlankFound As Integer

    If RecordPos = 0 Then
        BlankFound = False
        FileSize = LOF(ImageLinkFile) \ Len(HotSpotRecord)
        Counter = 0
        Do Until (Counter >= FileSize) Or BlankFound
            Counter = Counter + 1
            Get ImageLinkFile, Counter, TempRecord
            BlankFound = (Len(RTrim$(TempRecord.Image)) = 0)
            Loop
        If BlankFound Then
            RecordPos = Counter
          Else
            RecordPos = FileSize + 1
          End If
      End If
    Put ImageLinkFile, RecordPos, HotSpotRecord
    End Sub

