VERSION 2.00
Begin Form HotSpot2F1 
   Caption         =   "Rectangular Hot Spot Regions Editor"
   ClientHeight    =   3756
   ClientLeft      =   2040
   ClientTop       =   3108
   ClientWidth     =   5940
   DrawMode        =   6  'Invert
   Height          =   4500
   Left            =   1992
   LinkTopic       =   "Form1"
   ScaleHeight     =   3756
   ScaleWidth      =   5940
   Top             =   2412
   Width           =   6036
   Begin CommonDialog ImageFileDialog 
      DefaultExt      =   "*.BMP;*.DIB"
      Filter          =   "Pictures|*.BMP;*.DIB"
      Left            =   0
      Top             =   3360
   End
   Begin Menu FileOption 
      Caption         =   "File"
      Begin Menu LoadOption 
         Caption         =   "Load Picture"
      End
      Begin Menu NewOption 
         Caption         =   "New Hotspot"
      End
      Begin Menu EditOption 
         Caption         =   "Edit Saved Hotspot"
      End
      Begin Menu SaveOption 
         Caption         =   "Save Hotspot"
      End
      Begin Menu DeleteOption 
         Caption         =   "Delete Hotspot"
      End
      Begin Menu QuitOption 
         Caption         =   "Quit"
      End
   End
   Begin Menu ModeOption 
      Caption         =   "Mode"
      Begin Menu DefineOption 
         Caption         =   "Define"
         Checked         =   -1  'True
      End
      Begin Menu TestOption 
         Caption         =   "Test"
      End
   End
End
Option Explicit

Dim DrawingRectangle As Integer

Sub DefineOption_Click ()

    DefineOption.Checked = True
    TestOption.Checked = False
    DeleteRegion hRectRgn
    End Sub

Sub DeleteOption_Click ()
    Dim Response As Integer

    If CurrentHotspotRecordNumber > 0 Then
	Response = MsgBox("Are you sure you want to delete this Hotspot?", MB_YESNO + MB_ICONQUESTION, "Warning!")
	If Response = IDYES Then
	    SaveOption.Enabled = False
	    DeleteOption.Enabled = False
	    InitRecordBuffer
	    SaveHotspotRecord HotSpotRecord, CurrentHotspotRecordNumber
	    CurrentHotspotRecordNumber = 0
	    Line (AnchorX, AnchorY)-(EndX, EndY), , B
	    AnchorX = 0
	    AnchorY = 0
	    EndX = 0
	    EndY = 0
	    TestOption.Checked = False
	    DefineOption.Checked = True
	    DeleteRegion hRectRgn
	  End If
	Else
	  MsgBox "There is no region to delete.", 48, "Delete Error"
      End If
    End Sub

Sub EditOption_Click ()
    HotSpot2F1.Line (AnchorX, AnchorY)-(EndX, EndY), , B
    DeleteRegion hRectRgn
    HotSpot2F2.Show MODAL
    If TestOption.Checked Then
	hRectRgn = CreateRectRgn(AnchorX, AnchorY, EndX, EndY)
      End If
    HotSpot2F1.Refresh
    End Sub

Sub Form_Load ()
    NewOption.Enabled = False
    EditOption.Enabled = False
    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordNumber = 0
    DrawingRectangle = False
    Open App.Path + "\ImagLink.Dat" For Random As ImageLinkFile Len = Len(HotSpotRecord)
    InitRecordBuffer
    End Sub

Sub Form_MouseDown (Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim Dummy As Integer

    If DefineOption.Checked And (Len(CurrentImageFilename) > 0) Then
	Line (AnchorX, AnchorY)-(EndX, EndY), , B
	AnchorX = x
	AnchorY = y
	EndX = x
	EndY = y
	DrawingRectangle = True
      Else
	' Test whether click is in region.
	If PtInRegion(hRectRgn, x, y) Then
	    Dummy = mciExecute("play c:\windows\tada.wav")
	  Else
	    Dummy = mciExecute("play c:\windows\ding.wav")
	  End If
      End If
    End Sub

Sub Form_MouseMove (Button As Integer, Shift As Integer, x As Single, y As Single)
    If DrawingRectangle Then
	' Undraw the previous rectangle.
	Line (AnchorX, AnchorY)-(EndX, EndY), , B
	' Record the new coordinates of
	' the new end point.
	EndX = x
	EndY = y
	' Draw the new rectangle.
	Line (AnchorX, AnchorY)-(EndX, EndY), , B
      End If
    End Sub

Sub Form_MouseUp (Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim TempInt As Integer

    If DrawingRectangle Then
	If ((x <> AnchorX) Or (y <> AnchorY)) Then
	    EndX = x
	    EndY = y
	    ' If rectangle drawn upside down or
	    ' backwards, invert it.
	    If EndX < AnchorX Then
		TempInt = AnchorX
		AnchorX = EndX
		EndX = TempInt
	      End If
	    If EndY < AnchorY Then
		TempInt = AnchorY
		AnchorY = EndY
		EndY = TempInt
	      End If
	    SaveOption.Enabled = True
	  Else
	    SaveOption.Enabled = False
	  End If
      End If
    DrawingRectangle = False
    End Sub

Sub Form_Paint ()
    Line (AnchorX, AnchorY)-(EndX, EndY), , B
    End Sub

Sub Form_Unload (Cancel As Integer)
    DeleteRegion hRectRgn
    Close ImageLinkFile
    End Sub

Sub LoadOption_Click ()

    NewOption.Enabled = True
    EditOption.Enabled = True
    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordNumber = 0
    DrawingRectangle = False
    InitRecordBuffer
    AnchorX = 0
    AnchorY = 0
    EndX = 0
    EndY = 0
    DeleteRegion hRectRgn
    ImageFileDialog.Action = 1
    If ImageFileDialog.Filename <> "" Then
	CurrentImageFilename = ImageFileDialog.Filename
	HotSpot2F1.Picture = LoadPicture(CurrentImageFilename)
      End If
    End Sub

Sub NewOption_Click ()

    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordNumber = 0
    InitRecordBuffer
    Line (AnchorX, AnchorY)-(EndX, EndY), , B
    AnchorX = 0
    AnchorY = 0
    EndX = 0
    EndY = 0
    TestOption.Checked = False
    DefineOption.Checked = True
    DeleteRegion hRectRgn
    End Sub

Sub QuitOption_Click ()
    Form_Unload (0)
    End
    End Sub

Sub SaveOption_Click ()
    Dim TempString As String
    
    TempString = RTrim$(HotSpotRecord.Target)
    TempString = InputBox$("Enter a Hyperlink Target string of up to 128 characters:", "Enter Target", TempString)
    If Len(TempString) > 0 Then
	HotSpotRecord.Image = CurrentImageFilename
	HotSpotRecord.Target = TempString
	HotSpotRecord.TopX = AnchorX
	HotSpotRecord.TopY = AnchorY
	HotSpotRecord.BottomX = EndX
	HotSpotRecord.BottomY = EndY
	SaveHotspotRecord HotSpotRecord, CurrentHotspotRecordNumber
	DeleteOption.Enabled = True
      End If
    End Sub

Sub TestOption_Click ()
    DefineOption.Checked = False
    TestOption.Checked = True
    hRectRgn = CreateRectRgn(AnchorX, AnchorY, EndX, EndY)
    End Sub

