VERSION 2.00
Begin Form HotSpot3F1 
   Caption         =   "Hot Spot Editor"
   ClientHeight    =   4056
   ClientLeft      =   828
   ClientTop       =   2496
   ClientWidth     =   6420
   ClipControls    =   0   'False
   DrawMode        =   6  'Invert
   Height          =   4800
   Left            =   780
   LinkTopic       =   "Form1"
   ScaleHeight     =   338
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   535
   Top             =   1800
   Width           =   6516
   Begin Menu FileMenu 
      Caption         =   "File"
      Begin Menu NewOption 
         Caption         =   "New"
      End
      Begin Menu QuitOption 
         Caption         =   "Quit"
      End
   End
   Begin Menu Option 
      Caption         =   "Mode"
      Begin Menu DefineOption 
         Caption         =   "Defining Region"
         Checked         =   -1  'True
      End
      Begin Menu TestOption 
         Caption         =   "Testing Region"
      End
   End
End
Option Explicit

Dim hPolyRgn As Integer
Dim PolygonVertices(99) As POINTAPI
Dim PreviousX As Integer
Dim PreviousY As Integer
Dim CurrentPointIndex As Integer
Dim DrawingPolygon As Integer

Sub DefineOption_Click ()
    TestOption.Checked = False
    DefineOption.Checked = True
    DeleteRegion hPolyRgn
    End Sub

Sub Form_Load ()
    InitPolygonEditor
    End Sub

Sub Form_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim Dummy As Integer

    If DefineOption.Checked Then
	If DrawingPolygon Then
	    DrawingPolygon = Not VertexFinishesPolygon(X, Y)
	    PreviousX = X
	    PreviousY = Y
	  Else
	    Dummy = mciExecute("play c:\windows\ding.wav")
	    MsgBox "This polygon region is closed", 16, "Drawing Error"
	  End If
      Else
	' Test whether click is in region.
	If PtInRegion(hPolyRgn, X, Y) Then
	    Dummy = mciExecute("play c:\windows\tada.wav")
	  Else
	    Dummy = mciExecute("play c:\windows\ding.wav")
	  End If
      End If
    End Sub

Sub Form_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    If DrawingPolygon And (CurrentPointIndex > -1) Then
	Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
	PreviousX = X
	PreviousY = Y
	Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
      End If
    End Sub

Sub Form_Paint ()
    Dim I As Integer
    
    If CurrentPointIndex > 1 Then
	For I = 1 To CurrentPointIndex
	    Line (PolygonVertices(I - 1).X, PolygonVertices(I - 1).Y)-(PolygonVertices(I).X, PolygonVertices(I).Y)
	    Next I
	If Not DrawingPolygon Then
	    Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PolygonVertices(0).X, PolygonVertices(0).Y)
	  End If
      End If
    End Sub

Sub Form_Unload (Cancel As Integer)
    DeleteRegion hPolyRgn
    End Sub

Sub InitPolygonEditor ()
    Dim I As Integer
    
    DeleteRegion hPolyRgn
    If CurrentPointIndex > 1 Then
	For I = 1 To CurrentPointIndex
	    Line (PolygonVertices(I - 1).X, PolygonVertices(I - 1).Y)-(PolygonVertices(I).X, PolygonVertices(I).Y)
	    Next I
	If Not DrawingPolygon Then
	    Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PolygonVertices(0).X, PolygonVertices(0).Y)
	  End If
      End If
    CurrentPointIndex = -1
    DrawingPolygon = True
    End Sub

Sub NewOption_Click ()
    If DrawingPolygon Then
	Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
      End If
    InitPolygonEditor
    TestOption.Checked = False
    DefineOption.Checked = True
    End Sub

Sub QuitOption_Click ()
    Form_Unload (0)
    End
    End Sub

Sub TestOption_Click ()
    If DrawingPolygon Then
	MsgBox "Cannot Test Incomplete Polygon", 48, "Error"
      Else
	DefineOption.Checked = False
	TestOption.Checked = True
	hPolyRgn = CreatePolygonRgn(PolygonVertices(0), CurrentPointIndex + 1, 0)
      End If
    End Sub

Function VertexFinishesPolygon (X As Single, Y As Single) As Integer
    If (CurrentPointIndex > 0) And ((Sqr((X - PolygonVertices(0).X) ^ 2 + (Y - PolygonVertices(0).Y) ^ 2) <= 10) Or (CurrentPointIndex = 99)) Then
	HotSpot3F1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
	HotSpot3F1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PolygonVertices(0).X, PolygonVertices(0).Y)
	VertexFinishesPolygon = True
      Else
	CurrentPointIndex = CurrentPointIndex + 1
	PolygonVertices(CurrentPointIndex).X = X
	PolygonVertices(CurrentPointIndex).Y = Y
	VertexFinishesPolygon = False
      End If
    End Function

