Option Explicit

Type POINTAPI
    X As Integer
    Y As Integer
    End Type

Declare Function CreatePolygonRgn Lib "GDI" (lpPoints As POINTAPI, ByVal nCount As Integer, ByVal nPolyFillMode As Integer) As Integer
Declare Function PtInRegion Lib "GDI" (ByVal hRgn As Integer, ByVal X As Integer, ByVal Y As Integer) As Integer
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer

Declare Function mciExecute Lib "MMSystem" (ByVal CommandString As String) As Integer

Global ImageDB As Database
Global ImageTable As Table
Global CurrentHotspotRecordID As Long
Global CurrentImageFilename As String
Global hPolyRgn As Integer
Global PolygonVertices(99) As POINTAPI
Global PreviousX As Integer
Global PreviousY As Integer
Global CurrentPointIndex As Integer
Global DatabaseOpen As Integer

Function ArrayFromString (TheVertexArray() As POINTAPI, ByVal TheString As String) As Integer
    Dim I As Integer
    Dim LastElement As Integer

    LastElement = Len(TheString) \ 4 - 1
    For I = 0 To LastElement
	TheVertexArray(I).X = Asc(Mid$(TheString, I * 4 + 1, 1)) * 256 + Asc(Mid$(TheString, I * 4 + 2, 1))
	TheVertexArray(I).Y = Asc(Mid$(TheString, I * 4 + 3, 1)) * 256 + Asc(Mid$(TheString, I * 4 + 4, 1))
	Next I
    ArrayFromString = LastElement
    End Function

Sub DeleteRegion (hRgn As Integer)
    If hRgn <> 0 Then
	If DeleteObject(hRgn) Then
	    hRgn = 0
	  Else
	    MsgBox "Unable to Delete Region", 48, "GDI Error"
	  End If
      End If
    End Sub

Sub DrawPolygon (VertexArray() As POINTAPI, LastArrayIndex As Integer, ThePicture As PictureBox, CompletePolygon As Integer)
    Dim I As Integer
    
    If LastArrayIndex > 0 Then
	For I = 1 To LastArrayIndex
	    ThePicture.Line (VertexArray(I - 1).X, VertexArray(I - 1).Y)-(VertexArray(I).X, VertexArray(I).Y)
	    Next I
	If CompletePolygon Then
	    ThePicture.Line (VertexArray(LastArrayIndex).X, VertexArray(LastArrayIndex).Y)-(VertexArray(0).X, VertexArray(0).Y)
	  End If
      End If
    End Sub

Function LoadHotSpot (ImageFilename As String, ByVal RecordID As Long) As Integer
    Dim TempString As String

    ImageTable.Index = "PrimaryKey"
    ImageTable.Seek "=", ImageFilename, RecordID
    If Not ImageTable.NoMatch Then
	CurrentImageFilename = ImageTable!ImageFilename
	TempString = ImageTable!VertexArray
	CurrentPointIndex = ArrayFromString(PolygonVertices(), TempString)
	CurrentHotspotRecordID = ImageTable!HotSpotNum
	LoadHotSpot = True
      Else
	LoadHotSpot = False
      End If
    End Function

Function OpenImageDatabase () As Integer
    '  Opens the file IMAGES.MDB.  If file does
    '  not exist, this function will create it.
    Dim Fld() As New Field
    Dim Idx() As New Index
    Dim ImageTableDef As New TableDef
    Dim Counter As Integer

    If Len(Dir$(App.Path + "\Images.MDB")) > 0 Then
	Set ImageDB = OpenDatabase(App.Path + "\Images.MDB")
	Set ImageTable = ImageDB.OpenTable("ImageTable")
      Else
	' Create database Images.MDB
	Set ImageDB = CreateDatabase(App.Path + "\Images.MDB", DB_LANG_GENERAL)
	' Create Image Table
	ImageTableDef.Name = "ImageTable"
	' Create Fields.
	ReDim Fld(1 To 4)
	Fld(2).Attributes = DB_AUTOINCRFIELD    ' Counter field.
	For Counter = 1 To 4  ' Set properties for fields.
	    Fld(Counter).Name = Choose(Counter, "ImageFileName", "HotSpotNum", "LinkTarget", "VertexArray")
	    Fld(Counter).Type = Choose(Counter, DB_TEXT, DB_LONG, DB_TEXT, DB_LONGBINARY)
	    Fld(Counter).Size = Choose(Counter, 128, 4, 128, 400)
	    ImageTableDef.Fields.Append Fld(Counter)
	    Next Counter
    
	' Create Table Index.
	ReDim Idx(1)
	Idx(1).Name = "PrimaryKey"
	Idx(1).Fields = "ImageFileName;HotSpotNum"
	Idx(1).Primary = True
	Idx(1).Unique = True
	ImageTableDef.Indexes.Append Idx(1)
    
	' Create Table.
	ImageDB.TableDefs.Append ImageTableDef
	ImageDB.Close
	Set ImageDB = OpenDatabase(App.Path + "\Images.MDB")
	Set ImageTable = ImageDB.OpenTable("ImageTable")
      End If
    End Function

Sub SaveHotspotRecord ()
    Dim TempTarget As String
    Dim ArrayString As String

    ArrayString = StringFromArray(PolygonVertices(), CurrentPointIndex)
    If CurrentHotspotRecordID = 0 Then
	' Add new record
	TempTarget = ""
	TempTarget = InputBox$("Enter a Hyperlink Target string of up to 128 characters: ", "Enter Target", TempTarget)
	If Len(TempTarget) > 0 Then
	    ImageTable.AddNew
	    ImageTable!ImageFilename = CurrentImageFilename
	    ImageTable!LinkTarget = TempTarget
	    ImageTable!VertexArray = ArrayString
	    ImageTable.Update
	  End If
      Else
	' Replace existing record
	ImageTable.Seek "=", CurrentImageFilename, CurrentHotspotRecordID
	If Not ImageTable.NoMatch Then
	    TempTarget = ImageTable!LinkTarget
	    TempTarget = InputBox$("enter a Hyperlink Target string of up to 128 characters: ", "Enter Target", TempTarget)
	    If Len(TempTarget) > 0 Then
		ImageTable.Edit
		ImageTable!ImageFilename = CurrentImageFilename
		ImageTable!LinkTarget = TempTarget
		ImageTable!VertexArray = ArrayString
		ImageTable.Update
	      End If
	  Else
	    MsgBox "Unable to Relocate Record", 48, "Database Error"
	  End If
      End If
    End Sub

Function StringFromArray (VertexArray() As POINTAPI, LastArrayIndex As Integer) As String
    Dim I As Integer
    Dim TempString As String
    
    TempString = ""
    For I = 0 To LastArrayIndex
	TempString = TempString + Chr$(VertexArray(I).X \ 256)
	TempString = TempString + Chr$(VertexArray(I).X Mod 256)
	TempString = TempString + Chr$(VertexArray(I).Y \ 256)
	TempString = TempString + Chr$(VertexArray(I).Y Mod 256)
	Next I
    StringFromArray = TempString
    End Function

