VERSION 2.00
Begin Form HotSpot4F1 
   Caption         =   "Hot Spot Editor"
   ClientHeight    =   4056
   ClientLeft      =   1764
   ClientTop       =   2736
   ClientWidth     =   6420
   Height          =   4800
   Left            =   1716
   LinkTopic       =   "Form1"
   ScaleHeight     =   4056
   ScaleWidth      =   6420
   Top             =   2040
   Width           =   6516
   Begin CommonDialog ImageFileDialog 
      Left            =   120
      Top             =   3600
   End
   Begin PictureBox Picture1 
      ClipControls    =   0   'False
      DrawMode        =   6  'Invert
      Height          =   3252
      Left            =   480
      ScaleHeight     =   269
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   459
      TabIndex        =   0
      Top             =   240
      Width           =   5532
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu LoadOption 
         Caption         =   "&Load Picture"
      End
      Begin Menu NewOption 
         Caption         =   "&New"
      End
      Begin Menu EditOption 
         Caption         =   "&Edit Saved Hotspot"
      End
      Begin Menu SaveOption 
         Caption         =   "&Save Hotspot"
      End
      Begin Menu DeleteOption 
         Caption         =   "&Delete Hotspot"
      End
      Begin Menu QuitOption 
         Caption         =   "&Quit"
      End
   End
   Begin Menu ModeMenu 
      Caption         =   "&Mode"
      Begin Menu DefineOption 
         Caption         =   "&Defining Region"
         Checked         =   -1  'True
      End
      Begin Menu TestOption 
         Caption         =   "&Testing Region"
      End
   End
End
Option Explicit

Dim DrawingPolygon As Integer

Sub DefineOption_Click ()
    TestOption.Checked = False
    DefineOption.Checked = True
    DeleteRegion hPolyRgn
    End Sub

Sub DeleteOption_Click ()
    Dim Response As Integer

    If CurrentHotspotRecordID > 0 Then
	Response = MsgBox("Are you sure you want to delete this Hotspot?", MB_YESNO + MB_ICONQUESTION, "Warning!")
	If Response = IDYES Then
	    ImageTable.Seek "=", CurrentImageFilename, CurrentHotspotRecordID
	    If Not ImageTable.NoMatch Then
		ImageTable.Delete
		SaveOption.Enabled = False
		DeleteOption.Enabled = False
		InitPolygonEditor
		DrawPolygon PolygonVertices(), CurrentPointIndex, Picture1, Not DrawingPolygon
		PreviousX = 0
		PreviousY = 0
		TestOption.Checked = False
		DefineOption.Checked = True
		DeleteRegion hPolyRgn
	      Else
		MsgBox "Unable to Relocate Hotspot Record.", 48, "Database Error"
	      End If
	  End If
	Else
	  MsgBox "There is no region to delete.", 48, "Delete Error"
	End If
    End Sub

Sub EditOption_Click ()
    DrawPolygon PolygonVertices(), CurrentPointIndex, Picture1, Not DrawingPolygon
    DeleteRegion hPolyRgn
    DrawingPolygon = False
    HotSpot4F2.Show MODAL
    If CurrentHotspotRecordID > 0 Then
	SaveOption.Enabled = True
	DeleteOption.Enabled = True
      End If
    If TestOption.Checked Then
	hPolyRgn = CreatePolygonRgn(PolygonVertices(0), CurrentPointIndex + 1, 0)
      End If
    HotSpot4F1.Refresh
    End Sub

Sub Form_Load ()
    NewOption.Enabled = False
    EditOption.Enabled = False
    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordID = 0&
    DatabaseOpen = OpenImageDatabase()
    InitPolygonEditor
    End Sub

Sub Form_Resize ()
    Picture1.Width = .9 * HotSpot4F1.ScaleWidth
    Picture1.Height = .9 * HotSpot4F1.ScaleHeight
    Picture1.Left = HotSpot4F1.ScaleWidth \ 2 - Picture1.Width \ 2
    Picture1.Top = HotSpot4F1.ScaleHeight \ 2 - Picture1.Height \ 2
    End Sub

Sub Form_Unload (Cancel As Integer)
    DeleteRegion hPolyRgn
    ImageTable.Close
    ImageDB.Close
    End Sub

Sub InitPolygonEditor ()
    DeleteRegion hPolyRgn
    DrawPolygon PolygonVertices(), CurrentPointIndex, Picture1, Not DrawingPolygon
    CurrentPointIndex = -1
    CurrentHotspotRecordID = 0&
    PreviousX = 0
    PreviousY = 0
    DrawingPolygon = True
    End Sub

Sub LoadOption_Click ()
    NewOption.Enabled = True
    EditOption.Enabled = True
    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordID = 0&
    InitPolygonEditor
    ImageFileDialog.Filter = "Bitmaps *.BMP|*.BMP|Device Independent Bitmaps *.DIB|*.DIB"
    ImageFileDialog.Action = 1
    If ImageFileDialog.Filename <> "" Then
	CurrentImageFilename = Mid$(ImageFileDialog.Filename, 3)
	Picture1.Picture = LoadPicture(CurrentImageFilename)
      End If
    End Sub

Sub NewOption_Click ()
    SaveOption.Enabled = False
    DeleteOption.Enabled = False
    CurrentHotspotRecordID = 0&
    If DrawingPolygon And (CurrentPointIndex > -1) Then
	Picture1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
      End If
    InitPolygonEditor
    TestOption.Checked = False
    DefineOption.Checked = True
    DeleteRegion hPolyRgn
    End Sub

Sub Picture1_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Dim Dummy As Integer

    If DefineOption.Checked And (Len(CurrentImageFilename) > 0) Then
	If DrawingPolygon Then
	    DrawingPolygon = Not VertexFinishesPolygon(X, Y)
	    PreviousX = X
	    PreviousY = Y
	  Else
	    Dummy = mciExecute("play c:\windows\ding.wav")
	    MsgBox "This polygon region is closed", 16, "Drawing Error"
	  End If
	  Else
	' Test whether click is in region.
	If PtInRegion(hPolyRgn, X, Y) Then
	    Dummy = mciExecute("play c:\windows\tada.wav")
	  Else
	    Dummy = mciExecute("play c:\windows\ding.wav")
	  End If
      End If

    End Sub

Sub Picture1_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    If DrawingPolygon And (CurrentPointIndex > -1) Then
	Picture1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
	PreviousX = X
	PreviousY = Y
	Picture1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
      End If
    End Sub

Sub Picture1_Paint ()
    DrawPolygon PolygonVertices(), CurrentPointIndex, Picture1, Not DrawingPolygon
    End Sub

Sub QuitOption_Click ()
    Form_Unload (0)
    End
    End Sub

Sub SaveOption_Click ()
    SaveHotspotRecord
    End Sub

Sub TestOption_Click ()
    If DrawingPolygon Then
	MsgBox "Cannot Test Incomplete Polygon", 48, "Error"
      Else
	DefineOption.Checked = False
	TestOption.Checked = True
	hPolyRgn = CreatePolygonRgn(PolygonVertices(0), CurrentPointIndex + 1, 0)
      End If
    End Sub

Function VertexFinishesPolygon (X As Single, Y As Single) As Integer
    If (CurrentPointIndex > 0) And ((Sqr((X - PolygonVertices(0).X) ^ 2 + (Y - PolygonVertices(0).Y) ^ 2) <= 10) Or (CurrentPointIndex = 99)) Then
	Picture1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PreviousX, PreviousY)
	Picture1.Line (PolygonVertices(CurrentPointIndex).X, PolygonVertices(CurrentPointIndex).Y)-(PolygonVertices(0).X, PolygonVertices(0).Y)
	VertexFinishesPolygon = True
	SaveOption.Enabled = True
      Else
	CurrentPointIndex = CurrentPointIndex + 1
	PolygonVertices(CurrentPointIndex).X = X
	PolygonVertices(CurrentPointIndex).Y = Y
	VertexFinishesPolygon = False
      End If
    End Function

