Option Explicit

Declare Function mciExecute Lib "MMSystem" (ByVal CommandString As String) As Integer

Type HyperLinkElement
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
    DestinationSubject As String * 128
    End Type

Type HyperTextRecords 'To store text as linked list of lines
    TextBlock As String * 128
    NextBlock As Long
    End Type

Type SubjectIndexRecords
    Subject As String * 128
    FilePos As Long
    End Type

Dim CurrentTop As Single
Dim LinkArrayPos As Integer
Dim ArrayPlaceHolder As Integer

Dim HyperLinkArray(100) As HyperLinkElement
Dim SubjectIndexArray(100) As SubjectIndexRecords
Dim HyperLinkArraySize As Integer

Dim HyperTextRecord As HyperTextRecords
Dim SubjectIndexRecord As SubjectIndexRecords
Dim NumberOfSubjects As Integer
'Dim IndexPos As Long
'Dim LinkPos As Long

Dim LinkFileNum As Integer
Dim IndexFileNum As Integer

Global FilesAreOpen As Integer
Global CurrentSubject As String


Global TextLineArray(500) As String
Global FirstTextLineNumber As Integer
Global LastTextLineNumber As Integer

Sub DisplaySubject (ThePicture As PictureBox, StartLine As Integer, MaxLine As Integer)
    Dim StringToPrint As String
    Dim CreatingALink As Integer
    Dim NextWord As String
    Dim TempWord As String
    Dim LineCounter As Integer
    Dim TargetString As String

    ThePicture.Cls
    LinkArrayPos = 0
    ArrayPlaceHolder = 1
    LineCounter = StartLine
    
    If StartLine = 0 Then
        ' Display Subject name as heading.
        ThePicture.FontBold = False
        ThePicture.ForeColor = BLUE
        ThePicture.FontSize = 16
        ThePicture.CurrentX = 200
        ThePicture.Print RTrim$(TextLineArray(0))
        ThePicture.Print
        LineCounter = 2
      End If
    ' Set base text attributes.
    ThePicture.ForeColor = BLACK
    ThePicture.FontSize = 12
    Do Until (ThePicture.CurrentY > ThePicture.ScaleHeight) Or (LineCounter > MaxLine)
        If TextLineArray(LineCounter) = "" Then
            NewLine ThePicture
          Else
            ThePicture.CurrentX = 200
            StringToPrint = TextLineArray(LineCounter)
            CurrentTop = ThePicture.CurrentY
            NextWord = GetWordFrom(StringToPrint)
            Do While NextWord <> ""
                If Left$(NextWord, 2) = "##" Then
                    ParseLink NextWord, TempWord, TargetString
                    TempWord = TempWord + Left$(StringToPrint, 1)
                    StringToPrint = Mid$(StringToPrint, 2)
                    CreatingALink = True
                  Else
                    TempWord = NextWord
                    CreatingALink = False
                  End If
                If CreatingALink Then
                    LinkArrayPos = LinkArrayPos + 1
                    HyperLinkArray(LinkArrayPos).Left = ThePicture.CurrentX
                    HyperLinkArray(LinkArrayPos).Top = CurrentTop
                    ThePicture.FontBold = True
                    ThePicture.Print TempWord;
                    ThePicture.FontBold = False
                    HyperLinkArray(LinkArrayPos).Right = ThePicture.CurrentX
                    HyperLinkArray(LinkArrayPos).DestinationSubject = TargetString
                  Else
                    ThePicture.Print TempWord;
                  End If
                NextWord = GetWordFrom(StringToPrint)
                Loop
            NewLine ThePicture
          End If
        LineCounter = LineCounter + 1
        Loop
    HyperLinkArraySize = LinkArrayPos

    End Sub

Sub DoHyperTextJump (TargetString As String, ThePicture As PictureBox, TheScrollBar As VScrollBar)
    Dim Dummy As Integer

    If Left$(Right$(TargetString, 4), 1) = "." Then
        Dummy = mciExecute("Play " + TargetString)
      Else
        LoadSubject TargetString, ThePicture, TheScrollBar
      End If
    End Sub

Function GetWordFrom (AnyString As String) As String
    If Left$(AnyString, 1) = "#" Then
        GetWordFrom = Left$(AnyString, InStr(AnyString, "~"))
        AnyString = Mid$(AnyString, InStr(AnyString, "~") + 1)
      ElseIf InStr(AnyString, " ") = 0 Then
        GetWordFrom = AnyString
        AnyString = ""
      Else
        GetWordFrom = Left$(AnyString, InStr(AnyString, " "))
        AnyString = Mid$(AnyString, InStr(AnyString, " ") + 1)
      End If
    End Function

Sub InitializeHyperEngine ()
    CurrentSubject = RTrim$(SubjectIndexArray(1).Subject)
    End Sub

Sub LoadShortSubject (Subject As String, ThePicture As PictureBox)
    Dim StringToPrint As String
    Dim CreatingALink As Integer
    Dim NextWord As String
    Dim TempWord As String
    Dim TargetString As String

    CurrentSubject = Subject
    StringToPrint = ReadInText(Subject)

    ThePicture.Cls
    LinkArrayPos = 0
    ArrayPlaceHolder = 1
    
    ' Display Subject name as heading.
    ThePicture.FontBold = False
    ThePicture.ForeColor = BLUE
    ThePicture.FontSize = 16
    ThePicture.CurrentX = 200
    ThePicture.Print RTrim$(Subject)
    ThePicture.Print

    ' Set base text attributes.
    ThePicture.ForeColor = BLACK
    ThePicture.FontSize = 12
    ThePicture.CurrentX = 200

    CurrentTop = ThePicture.CurrentY
    NextWord = GetWordFrom(StringToPrint)
    Do While NextWord <> ""
        If Left$(NextWord, 2) = "##" Then
            ParseLink NextWord, TempWord, TargetString
            TempWord = TempWord + Left$(StringToPrint, 1)
            StringToPrint = Mid$(StringToPrint, 2)
            CreatingALink = True
          Else
            TempWord = NextWord
            CreatingALink = False
          End If
        ' Insert a blank line between paragraphs.
        If Left$(TempWord, 1) = Chr$(13) Then
            NewLine ThePicture
            NewLine ThePicture
            ThePicture.CurrentX = 200
            TempWord = ""
          End If
        If ((ThePicture.CurrentX + ThePicture.TextWidth(TempWord)) > ThePicture.ScaleWidth) Then
            NewLine ThePicture
            ThePicture.CurrentX = 200
            End If
        If CreatingALink Then
            LinkArrayPos = LinkArrayPos + 1
            HyperLinkArray(LinkArrayPos).Left = ThePicture.CurrentX
            HyperLinkArray(LinkArrayPos).Top = CurrentTop
            ThePicture.FontBold = True
            ThePicture.Print TempWord;
            ThePicture.FontBold = False
            HyperLinkArray(LinkArrayPos).Right = ThePicture.CurrentX
            HyperLinkArray(LinkArrayPos).DestinationSubject = TargetString
          Else
            ThePicture.Print TempWord;
          End If
        NextWord = GetWordFrom(StringToPrint)
        Loop
    HyperLinkArraySize = LinkArrayPos
    NewLine ThePicture
    End Sub

Sub LoadSubject (Subject As String, ThePicture As PictureBox, TheScrollBar As VScrollBar)
    LastTextLineNumber = PrepareSubject(Subject, ThePicture)
    FirstTextLineNumber = 0
    
    TheScrollBar.Min = 0
    TheScrollBar.SmallChange = 1
    TheScrollBar.LargeChange = MinInt((ThePicture.ScaleHeight \ ThePicture.TextHeight("Any Text")) - 2, LastTextLineNumber - 1)
    If TheScrollBar.Value > 0 Then
        TheScrollBar.Value = 0
      Else
        ThePicture.Refresh
      End If
    TheScrollBar.Max = MaxInt((LastTextLineNumber - (ThePicture.ScaleHeight \ ThePicture.TextHeight("Any Text"))), 0)
    End Sub

Sub NewLine (ThePicture As PictureBox)
    ThePicture.Print
    
    CurrentTop = ThePicture.CurrentY
    While ArrayPlaceHolder <= LinkArrayPos
        HyperLinkArray(ArrayPlaceHolder).Bottom = ThePicture.CurrentY
        ArrayPlaceHolder = ArrayPlaceHolder + 1
        Wend
    End Sub

Sub OpenHyperbase (ByVal FileName As String)
    Dim RootFileName As String
    Dim LinkRecordLen As Integer
    Dim IndexRecordLen As Integer
    Dim IndexPos As Long

    LinkFileNum = 2
    IndexFileNum = 3
    NumberOfSubjects = 0
    LinkRecordLen = Len(HyperTextRecord)
    IndexRecordLen = Len(SubjectIndexRecord)
    If InStr(FileName, ".") > 0 Then
        RootFileName = Left$(FileName, InStr(FileName, ".") - 1)
      Else
        RootFileName = FileName
      End If
    If FilesAreOpen Then
        Close LinkFileNum
        Close IndexFileNum
        FilesAreOpen = False
        End If
    Open RootFileName + ".HTF" For Random As #LinkFileNum Len = LinkRecordLen
    Open RootFileName + ".IDX" For Random As #IndexFileNum Len = IndexRecordLen
    FilesAreOpen = True
    IndexPos = 0
    Do Until EOF(IndexFileNum)
        IndexPos = IndexPos + 1
        Get #IndexFileNum, IndexPos, SubjectIndexArray(IndexPos)
        Loop
    NumberOfSubjects = IndexPos - 1
    End Sub

Sub ParseLink (RawLink As String, LinkWord As String, Subject As String)
    Dim DelimiterPos As Integer
    Dim TildePos As Integer
    While Left$(RawLink, 1) = "#"
        RawLink = Mid$(RawLink, 2)
        Wend
    DelimiterPos = InStr(RawLink, "|")
    LinkWord = Left$(RawLink, DelimiterPos - 1)
    RawLink = Mid$(RawLink, DelimiterPos + 1)
    TildePos = InStr(RawLink, "~")
    Subject = Left$(RawLink, TildePos - 1)

    End Sub

Function PrepareSubject (Subject As String, ThePicture As PictureBox) As Integer
    Dim StringToPrint As String
    Dim CreatingALink As Integer
    Dim NextWord As String
    Dim TempWord As String
    Dim TargetString As String
    Dim TextLineArrayPos As Integer
    Dim UnparsedLink As String
    Dim TempLine As String
    Dim AccumulatedLineLength As Integer

    For TextLineArrayPos = 0 To 500
        TextLineArray(TextLineArrayPos) = ""
        Next TextLineArrayPos
    CurrentSubject = Subject
    StringToPrint = ReadInText(Subject)
    
    TextLineArray(0) = RTrim$(Subject)
    TextLineArrayPos = 2
    ' Set base text attributes.
    ThePicture.ForeColor = BLACK
    ThePicture.FontSize = 12
    
    AccumulatedLineLength = 200
    TempLine = ""
    NextWord = GetWordFrom(StringToPrint)
    Do While NextWord <> ""
        If Left$(NextWord, 2) = "##" Then
            UnparsedLink = NextWord
            ParseLink NextWord, TempWord, TargetString
            TempWord = TempWord + Left$(StringToPrint, 1)
            UnparsedLink = UnparsedLink + Left$(StringToPrint, 1)
            StringToPrint = Mid$(StringToPrint, 2)
            CreatingALink = True
            ThePicture.FontBold = True
          Else
            TempWord = NextWord
            CreatingALink = False
            ThePicture.FontBold = False
          End If
        ' Insert a blank line between paragraphs.
        If Left$(TempWord, 1) = Chr$(13) Then
            TextLineArrayPos = TextLineArrayPos + 2
            AccumulatedLineLength = 200
            TempLine = ""
            TempWord = ""
            End If
        If ((AccumulatedLineLength + ThePicture.TextWidth(TempWord)) > ThePicture.ScaleWidth) Then
            TextLineArrayPos = TextLineArrayPos + 1
            TempLine = TempWord
            AccumulatedLineLength = 200 + ThePicture.TextWidth(TempWord)
          Else
            TempLine = TempLine + TempWord
            AccumulatedLineLength = AccumulatedLineLength + ThePicture.TextWidth(TempWord)
          End If
        If CreatingALink Then
            TextLineArray(TextLineArrayPos) = TextLineArray(TextLineArrayPos) + UnparsedLink
          Else
            TextLineArray(TextLineArrayPos) = TextLineArray(TextLineArrayPos) + TempWord
          End If
        NextWord = GetWordFrom(StringToPrint)
        Loop
    TextLineArrayPos = TextLineArrayPos + 1
    PrepareSubject = TextLineArrayPos

    End Function

Function ReadInText (SubjectName As String) As String

    Dim ParagraphText As String
    Dim TempString As String
    Dim IndexPos As Integer
    Dim LinkPos As Long

    ParagraphText = ""
    IndexPos = 1
    ' Search for subject.
    Do Until (RTrim$(SubjectIndexArray(IndexPos).Subject) = SubjectName) Or (IndexPos > NumberOfSubjects)
        IndexPos = IndexPos + 1
        Loop
    ' If subject is found, read in text.
    If IndexPos <= NumberOfSubjects Then
        LinkPos = SubjectIndexArray(IndexPos).FilePos
        Do Until (LinkPos = 0) Or (EOF(LinkFileNum))
            Get #LinkFileNum, LinkPos, HyperTextRecord
            TempString = RTrim$(HyperTextRecord.TextBlock)
            ' Replace the substituted spaces.
            If Right$(TempString, 1) = Chr$(1) Then
                TempString = Left$(TempString, Len(TempString) - 1) + " "
              End If
            ParagraphText = TempString + ParagraphText
            LinkPos = HyperTextRecord.NextBlock
            Loop
        End If
    ReadInText = ParagraphText
    End Function

Sub CompileText (ByVal FileName As String)
    Dim LineOfText As String
    Dim RootFileName As String
    Dim ParagraphText As String
    Dim LinkRecordLen As Integer
    Dim IndexRecordLen As Integer
    Dim TextFileNum As Integer
    Dim PreviousTextPos As Long
    Dim IndexPos As Long
    Dim LinkPos As Long

    ParagraphText = ""

    LinkRecordLen = Len(HyperTextRecord)
    IndexRecordLen = Len(SubjectIndexRecord)
    TextFileNum = 1
    LinkFileNum = 2
    IndexFileNum = 3

    ' Extract the root file name from the source text file.
    If InStr(FileName, ".") > 0 Then
        RootFileName = Left$(FileName, InStr(FileName, ".") - 1)
      Else
        RootFileName = FileName
      End If
    Open FileName For Input As #TextFileNum
    If FilesAreOpen Then
        Close LinkFileNum
        Close IndexFileNum
        End If
    ' Eliminate pre-existing HTF and IDX files.
    ' They need to be opened first in case they don't exist
    ' so they will be created, otherwise we'll get an
    ' error when we try to Kill them.
    Open RootFileName + ".HTF" For Random As #LinkFileNum Len = LinkRecordLen
    Open RootFileName + ".IDX" For Random As #IndexFileNum Len = IndexRecordLen
    Close #LinkFileNum
    Close #IndexFileNum
    Kill RootFileName + ".HTF"
    Kill RootFileName + ".IDX"
    Open RootFileName + ".HTF" For Random As #LinkFileNum Len = LinkRecordLen
    Open RootFileName + ".IDX" For Random As #IndexFileNum Len = IndexRecordLen
    FilesAreOpen = True

    IndexPos = 0
    LinkPos = 0
    SubjectIndexRecord.Subject = ""
    SubjectIndexRecord.FilePos = 0
    ' Read and process the source text file line
    ' by line until we reach the end.
    Do While Not EOF(TextFileNum)
        Line Input #TextFileNum, LineOfText
        If (Left$(LineOfText, 3) <> "###") Then
            ' Append this line of the source text
            ' to the current Subject text buffer.
            If Len(LineOfText) = 0 Then
                ParagraphText = ParagraphText + " " + Chr$(13) + Chr$(10) + " "
              Else
                ParagraphText = ParagraphText + LineOfText
              End If
          End If
        If (Left$(LineOfText, 3) = "###") Or (EOF(TextFileNum)) Then
            ' We've reached the end of a Subject, so
            ' store its accumulated text and prepare to
            ' start the next one.
            PreviousTextPos = 0
            If Len(ParagraphText) > 0 Then
                HyperTextRecord.TextBlock = ""
                HyperTextRecord.NextBlock = 0
                Do While (Len(ParagraphText) > 0)
                    If Len(ParagraphText) > 128 Then
                        If Mid$(ParagraphText, 128, 1) = " " Then
                            HyperTextRecord.TextBlock = Left$(ParagraphText, 127) + Chr$(1)
                          Else
                            HyperTextRecord.TextBlock = Left$(ParagraphText, 128)
                          End If
                        ParagraphText = Mid$(ParagraphText, 129)
                      Else
                        HyperTextRecord.TextBlock = ParagraphText
                        ParagraphText = ""
                      End If
                    LinkPos = LinkPos + 1
                    HyperTextRecord.NextBlock = PreviousTextPos
                    Put #LinkFileNum, LinkPos, HyperTextRecord
                    PreviousTextPos = LinkPos
                    Loop
              End If
            ' Set the file pointer in the Subject record and
            ' save the record in the Subject Index file.
            SubjectIndexRecord.FilePos = PreviousTextPos
            If Len(RTrim$(SubjectIndexRecord.Subject)) > 0 Then
                IndexPos = IndexPos + 1
                Put #IndexFileNum, IndexPos, SubjectIndexRecord
                End If
            ' Create a new subject
            If Left$(LineOfText, 3) = "###" Then
                SubjectIndexRecord.Subject = Mid$(LineOfText, 4)
                SubjectIndexRecord.FilePos = 0
              Else
                SubjectIndexRecord.Subject = ""
                SubjectIndexRecord.FilePos = 0
              End If
          End If
        Loop
        ' If the source text ends with an orphan
        ' Subject header (it has no Subject text),
        ' save it anyway.
        If Len(RTrim$(SubjectIndexRecord.Subject)) > 0 Then
            IndexPos = IndexPos + 1
            Put #IndexFileNum, IndexPos, SubjectIndexRecord
            End If
        
        Close LinkFileNum
        Close IndexFileNum
        FilesAreOpen = False
        Close TextFileNum
    End Sub

Sub DisplayFirstTopic (ThePicture As PictureBox, TheScrollBar As VScrollBar)
    LoadSubject RTrim$(SubjectIndexArray(1).Subject), ThePicture, TheScrollBar
    End Sub

Function TargetFromPointInText (X As Single, Y As Single) As String
    Dim Counter As Integer
    Dim Found As Integer
    Dim TempTargetString As String

    TempTargetString = ""
    Found = False
    Counter = 0
    Do While (Counter < HyperLinkArraySize) And (Not Found)
        Counter = Counter + 1
        If (X > HyperLinkArray(Counter).Left) And (X < HyperLinkArray(Counter).Right) And (Y < HyperLinkArray(Counter).Bottom) And (Y > HyperLinkArray(Counter).Top) Then
            TempTargetString = RTrim$(HyperLinkArray(Counter).DestinationSubject)
            Found = True
          End If
        Loop
    TargetFromPointInText = TempTargetString
    End Function

