VERSION 2.00
Begin Form MakeMask 
   Caption         =   "Convert a Bitmap to a Sprite & Mask"
   ClientHeight    =   2376
   ClientLeft      =   864
   ClientTop       =   1860
   ClientWidth     =   8532
   Height          =   3120
   Left            =   816
   LinkTopic       =   "Form1"
   ScaleHeight     =   198
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   711
   Top             =   1164
   Width           =   8628
   Begin PictureBox BitmapPictureBox 
      Height          =   1812
      Left            =   120
      ScaleHeight     =   1788
      ScaleWidth      =   2520
      TabIndex        =   2
      Top             =   120
      Width           =   2544
   End
   Begin PictureBox MaskPictureBox 
      Height          =   1812
      Left            =   2880
      ScaleHeight     =   149
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   220
      TabIndex        =   1
      Top             =   144
      Width           =   2664
   End
   Begin PictureBox SpritePictureBox 
      Height          =   1812
      Left            =   5760
      ScaleHeight     =   149
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   209
      TabIndex        =   0
      Top             =   120
      Width           =   2532
   End
   Begin CommonDialog LoadBitmapDialog 
      DialogTitle     =   "Load Sprite Bitmap"
      Filter          =   "Pictures|*.BMP;*.DIB;*.ICO"
      Left            =   -12
      Top             =   1812
   End
   Begin Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Sprite"
      Height          =   228
      Left            =   6324
      TabIndex        =   5
      Top             =   2040
      Width           =   1488
   End
   Begin Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Mask"
      Height          =   264
      Left            =   3372
      TabIndex        =   4
      Top             =   2028
      Width           =   1560
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Original Bitmap"
      Height          =   264
      Left            =   588
      TabIndex        =   3
      Top             =   2040
      Width           =   1356
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu LoadBitmapOption 
         Caption         =   "&Load Bitmap"
      End
      Begin Menu MakeMaskOption 
         Caption         =   "&Make Mask"
      End
      Begin Menu SaveMaskOption 
         Caption         =   "&Save Mask"
         Enabled         =   0   'False
      End
      Begin Menu QuitOption 
         Caption         =   "&Quit"
      End
   End
End
Option Explicit

Dim bmBitmapFileHeader As BITMAPFILEHEADER
Dim bmBitmapInfo As BITMAPINFO
Dim hSpritePal As Integer
Dim PictureLoaded As Integer
Dim hBitmapPixelData As Integer
Dim hMaskPixelData As Integer
Dim hSpritePixelData As Integer

Sub BitmapPictureBox_Paint ()
    Dim RetValue As Integer
    Dim lpBitmapPixelData As Long

    If hBitmapPixelData <> 0 Then
        RetValue = SelectPalette(BitmapPictureBox.hDC, hSpritePal, False)
        RetValue = RealizePalette(BitmapPictureBox.hDC)
        lpBitmapPixelData = GlobalLock(hBitmapPixelData)
        RetValue = SetDIBitsToDevice(BitmapPictureBox.hDC, 0, 0, bmBitmapInfo.bmiHeader.biWidth, bmBitmapInfo.bmiHeader.biHeight, 0, 0, 0, bmBitmapInfo.bmiHeader.biHeight, lpBitmapPixelData, bmBitmapInfo, DIB_RGB_COLORS)
        RetValue = GlobalUnlock(hBitmapPixelData)
      End If
    End Sub

Sub CleanUp ()
    Dim RetValue As Integer
    
    If hSpritePal <> 0 Then
        RetValue = DeleteObject(hSpritePal)
        hSpritePal = 0
      End If
    If hBitmapPixelData <> 0 Then
        hBitmapPixelData = GlobalFree(hBitmapPixelData)
      End If
    If hMaskPixelData <> 0 Then
        hMaskPixelData = GlobalFree(hMaskPixelData)
      End If
    If hSpritePixelData <> 0 Then
        hSpritePixelData = GlobalFree(hSpritePixelData)
      End If
    PictureLoaded = False
    End Sub

Sub Form_Load ()
    PictureLoaded = False
    End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
    Dim RetValue As Integer

    RetValue = SelectPalette(BitmapPictureBox.hDC, DEFAULT_PALETTE, False)
    RetValue = SelectPalette(SpritePictureBox.hDC, DEFAULT_PALETTE, False)
    RetValue = SelectPalette(MaskPictureBox.hDC, DEFAULT_PALETTE, False)
    
    End Sub

Sub Form_Unload (Cancel As Integer)
    CleanUp
    End Sub

Sub LoadBitmapOption_Click ()
    Dim RetValue As Integer
    Dim SpritePalette As LOGPALETTE
    Dim lpSpritePixelData As Long

    If PictureLoaded Then
        Form_QueryUnload 0, 0
        CleanUp
      End If
    LoadBitmapDialog = 1
    If Len(LoadBitmapDialog.Filename) > 0 Then
        ReadBitmapFile LoadBitmapDialog.Filename, bmBitmapFileHeader, bmBitmapInfo, hBitmapPixelData
        If bmBitmapInfo.bmiHeader.biBitCount <> 8 Then
            MsgBox "Please load an 8-bit image.", 16, "Load Error"
            RetValue = GlobalFree(hBitmapPixelData)
          Else
            ConstructPaletteFromColorTable bmBitmapInfo.bmiColors(), SpritePalette
            hSpritePal = CreatePalette(SpritePalette)
            RetValue = SelectPalette(BitmapPictureBox, hSpritePal, False)
            RetValue = SelectPalette(SpritePictureBox, hSpritePal, False)
            RetValue = SelectPalette(MaskPictureBox, hSpritePal, False)
            RetValue = RealizePalette(SpritePictureBox)
            PictureLoaded = True
            BitmapPictureBox.Refresh
          End If
      End If
    End Sub

Sub MakeMaskOption_Click ()
    MousePointer = 11
    hMaskPixelData = ConvertImageToMask(bmBitmapInfo, hBitmapPixelData)
    hSpritePixelData = ConvertImageToSprite(bmBitmapInfo, hBitmapPixelData)
    BitmapPictureBox.Refresh
    MaskPictureBox.Refresh
    SpritePictureBox.Refresh
    MousePointer = 0
    End Sub

Sub MaskPictureBox_Paint ()
    Dim RetValue As Integer
    Dim lpMaskPixelData As Long

    If hMaskPixelData <> 0 Then
        RetValue = SelectPalette(MaskPictureBox.hDC, hSpritePal, False)
        RetValue = RealizePalette(MaskPictureBox.hDC)
        lpMaskPixelData = GlobalLock(hMaskPixelData)
        RetValue = SetDIBitsToDevice(MaskPictureBox.hDC, 0, 0, bmBitmapInfo.bmiHeader.biWidth, bmBitmapInfo.bmiHeader.biHeight, 0, 0, 0, bmBitmapInfo.bmiHeader.biHeight, lpMaskPixelData, bmBitmapInfo, DIB_RGB_COLORS)
        lpMaskPixelData = GlobalUnlock(hMaskPixelData)
      End If
    End Sub

Sub QuitOption_Click ()
   Unload MakeMask
   End
   End Sub

Sub SaveMaskOption_Click ()
    'SavePicture MaskPictureBox.Image, App.Path & "\TestMask.bmp"
    End Sub

Sub SpritePictureBox_Paint ()
    Dim RetValue As Integer
    Dim lpSpritePixelData As Long

    If hSpritePixelData <> 0 Then
        RetValue = SelectPalette(SpritePictureBox.hDC, hSpritePal, False)
        RetValue = RealizePalette(SpritePictureBox.hDC)
        lpSpritePixelData = GlobalLock(hSpritePixelData)
        RetValue = SetDIBitsToDevice(SpritePictureBox.hDC, 0, 0, bmBitmapInfo.bmiHeader.biWidth, bmBitmapInfo.bmiHeader.biHeight, 0, 0, 0, bmBitmapInfo.bmiHeader.biHeight, lpSpritePixelData, bmBitmapInfo, DIB_RGB_COLORS)
        lpSpritePixelData = GlobalUnlock(hSpritePixelData)
      End If
    End Sub

