VERSION 2.00
Begin Form MidiInTest 
   Caption         =   "Test MIDI In"
   ClientHeight    =   3108
   ClientLeft      =   864
   ClientTop       =   1524
   ClientWidth     =   5064
   Height          =   3528
   Left            =   816
   LinkTopic       =   "Form1"
   ScaleHeight     =   3108
   ScaleWidth      =   5064
   Top             =   1152
   Width           =   5160
   Begin ListBox MidiDevList 
      Height          =   1176
      Left            =   180
      TabIndex        =   1
      Top             =   120
      Width           =   2892
   End
   Begin PictureBox Picture1 
      Height          =   2832
      Left            =   3300
      ScaleHeight     =   234
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   124
      TabIndex        =   2
      Top             =   120
      Width           =   1512
   End
   Begin CommandButton StartStopButton 
      Caption         =   "Start"
      Height          =   432
      Left            =   180
      TabIndex        =   0
      Top             =   1500
      Width           =   1632
   End
   Begin VBMsg VBMsg1 
      Height          =   336
      Left            =   2520
      MessageCount    =   MIDIIN1.FRX:0000
      MessageList     =   MIDIIN1.FRX:0002
      MessageTypes    =   0  'Selected Messages
      PostDefault     =   0   'False
      Top             =   2640
      Width           =   336
   End
End
Option Explicit

Declare Function ScrollDC Lib "User" (ByVal hDC As Integer, ByVal dx As Integer, ByVal dy As Integer, lprcScroll As RECT, lprcClip As RECT, ByVal hRgnUpdate As Integer, lprcUpdate As Any) As Integer

Dim hMidiIn As Integer
Dim MidiInActive As Integer
Dim InputDeviceNumber As Integer

Sub Form_Load ()
    Dim NumMidiInDevices As Integer
    Dim DevCounter As Integer
    Dim RetValue As Integer
    Dim DeviceCaps As MIDIINCAPS
        
    VBMsg1.SubClasshWnd = MidiInTest.hWnd
    StartStopButton.Enabled = False
    NumMidiInDevices = midiInGetNumDevs()
    For DevCounter = 0 To NumMidiInDevices - 1
        RetValue = midiInGetDevCaps(DevCounter, DeviceCaps, Len(DeviceCaps))
        MidiDevList.AddItem DeviceCaps.szPName
        MidiDevList.ItemData(MidiDevList.NewIndex) = DevCounter
        Next DevCounter
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim RetValue As Integer

    RetValue = midiInStop(hMidiIn)
    RetValue = midiInClose(hMidiIn)

    End Sub

Sub MidiDevList_Click ()
    InputDeviceNumber = MidiDevList.ItemData(MidiDevList.ListIndex)
    StartStopButton.Enabled = True
    End Sub

Sub StartStopButton_Click ()
    Dim RetValue As Integer
    Dim NumMidiDevices As Integer
    
    If Not MidiInActive Then
        RetValue = midiInOpen(hMidiIn, InputDeviceNumber, MidiInTest.hWnd, 0, CALLBACK_WINDOW)
        If RetValue = 0 Then
            RetValue = midiInReset(hMidiIn)
            RetValue = midiInStart(hMidiIn)
            MidiInActive = True
            StartStopButton.Caption = "Stop"
            MidiDevList.Enabled = False
          Else
            MsgBox "Unable to open Midi Device.", 48, "Midi Device Error"
          End If
      Else
        RetValue = midiInStop(hMidiIn)
        RetValue = midiInClose(hMidiIn)
        MidiInActive = False
        StartStopButton.Caption = "Start"
        MidiDevList.Enabled = True
      End If
    End Sub

Sub VBMsg1_WindowMessage (hWindow As Integer, Msg As Integer, wParam As Integer, lParam As Long, RetVal As Long, CallDefProc As Integer)
    Dim MidiDataByte2 As Integer
    Dim MidiDataByte1 As Integer
    Dim MidiStatusByte As Integer
    Dim RetValue As Integer
    Dim AreaToScroll As RECT
    Dim LineHeight As Integer
    
    ' Scroll Picture Box 1 line.
    LineHeight = Picture1.TextHeight("A")
    If (Picture1.CurrentY > (Picture1.ScaleHeight - LineHeight)) Then
        AreaToScroll.Top = 0
        AreaToScroll.Left = 0
        AreaToScroll.Right = Picture1.ScaleWidth
        AreaToScroll.Bottom = Picture1.ScaleHeight
        RetValue = ScrollDC(Picture1.hDC, 0, -LineHeight, AreaToScroll, AreaToScroll, 0, ByVal 0&)
        Picture1.Line (0, Picture1.ScaleHeight - LineHeight)-(Picture1.ScaleWidth, Picture1.ScaleHeight), Picture1.BackColor, BF
        Picture1.CurrentX = 0
        Picture1.CurrentY = Picture1.ScaleHeight - LineHeight
      End If
    Select Case Msg
      Case MM_MIM_OPEN
        Picture1.Print "Device Open"
      Case MM_MIM_CLOSE
        Picture1.Print "Device Closed"
      Case Else
        MidiDataByte2 = lParam \ 65536
        MidiDataByte1 = (lParam Mod 65536) \ 256
        MidiStatusByte = lParam Mod 256
        ' Filter out Active Sensing messages, MIDI Status 254.
        If MidiStatusByte <> 254 Then
            Picture1.Print Str$(MidiStatusByte) & Str$(MidiDataByte1) & Str$(MidiDataByte2)
          End If
      End Select
    End Sub

