VERSION 2.00
Begin Form SpriteAnimationForm 
   Caption         =   "Sprite Animation Project 3"
   ClientHeight    =   5292
   ClientLeft      =   2628
   ClientTop       =   1740
   ClientWidth     =   5664
   Height          =   5712
   Left            =   2580
   LinkTopic       =   "Form1"
   ScaleHeight     =   441
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   472
   Top             =   1368
   Width           =   5760
   Begin CheckBox HideBufferCheck 
      Caption         =   "Hide Buffers"
      Height          =   252
      Left            =   4032
      TabIndex        =   3
      Top             =   3828
      Width           =   1524
   End
   Begin PictureBox OffscreenCompositePicture 
      AutoSize        =   -1  'True
      Height          =   1332
      Left            =   324
      ScaleHeight     =   109
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   183
      TabIndex        =   2
      Top             =   3852
      Width           =   2220
   End
   Begin Timer Timer1 
      Interval        =   100
      Left            =   4032
      Top             =   4212
   End
   Begin PictureBox BufferPicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   1104
      Left            =   2664
      ScaleHeight     =   90
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   97
      TabIndex        =   1
      Top             =   3816
      Width           =   1188
   End
   Begin PictureBox AnimationPicture 
      AutoSize        =   -1  'True
      Height          =   3540
      Left            =   168
      Picture         =   SPRITE3.FRX:0000
      ScaleHeight     =   293
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   441
      TabIndex        =   0
      Top             =   132
      Width           =   5316
   End
End
Option Explicit

Dim Forward As Integer
Dim Down As Integer
Dim CurrentLeft As Integer
Dim CurrentTop As Integer
Dim OldLeft As Integer
Dim OldTop As Integer
Dim CurrentSpriteCel As Integer

Dim bmBitmapFileHeader As BITMAPFILEHEADER
Dim bmBitmapInfo As BITMAPINFO
Dim hSpritePal As Integer
Dim hBitmapPixelData As Integer
Dim hMaskPixelData As Integer
Dim hSpritePixelData As Integer

Dim SpriteBitmapFiles() As String
Dim SpriteDIBHandles() As Integer
Dim NumberOfSprites As Integer

Sub AnimationPicture_Paint ()
    Dim Dummy As Integer
    Dim SpriteWidth As Integer
    Dim SpriteHeight As Integer
    Dim CurrentX As Integer
    Dim OffscreenCompositeWidth As Integer
    Dim OffscreenCompositeHeight As Integer
    Dim lpMaskPixelData As Long
    Dim lpSpritePixelData As Long

    If Forward Then
	SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
	CurrentX = CurrentLeft
      Else
	SpriteWidth = -bmBitmapInfo.bmiHeader.biWidth
	CurrentX = CurrentLeft + bmBitmapInfo.bmiHeader.biWidth - 1
      End If
    SpriteHeight = bmBitmapInfo.bmiHeader.biHeight
    OffscreenCompositeWidth = Abs(SpriteWidth) + Abs(CurrentLeft - OldLeft)
    OffscreenCompositeHeight = SpriteHeight + Abs(CurrentTop - OldTop)
    ' Copy bounding rectangle of old and new positions to offscreen composite buffer.
    Dummy = BitBlt(OffscreenCompositePicture.hDC, 0, 0, OffscreenCompositeWidth, OffscreenCompositeHeight, AnimationPicture.hDC, MinInt(OldLeft, CurrentLeft), MinInt(OldTop, CurrentTop), SRCCOPY)
    ' Restore previously covered area by copying hold buffer to composite buffer.
    Dummy = BitBlt(OffscreenCompositePicture.hDC, MaxInt(0, OldLeft - CurrentLeft), MaxInt(0, OldTop - CurrentTop), Abs(SpriteWidth), SpriteHeight, BufferPicture.hDC, 0, 0, SRCCOPY)
    ' Copy area that will become next position from composite buffer to hold buffer.
    Dummy = BitBlt(BufferPicture.hDC, 0, 0, Abs(SpriteWidth), SpriteHeight, OffscreenCompositePicture.hDC, MaxInt(0, CurrentLeft - OldLeft), MaxInt(0, CurrentTop - OldTop), SRCCOPY)
    ' Copy Mask and Sprite to composite buffer.
    lpMaskPixelData = GlobalLock(SpriteDIBHandles(CurrentSpriteCel, 1))
    lpSpritePixelData = GlobalLock(SpriteDIBHandles(CurrentSpriteCel, 2))
    Dummy = StretchDIBits(OffscreenCompositePicture.hDC, MaxInt(CurrentX - CurrentLeft, CurrentX - OldLeft), MaxInt(0, CurrentTop - OldTop), SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), SpriteHeight, lpMaskPixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCAND)
    Dummy = StretchDIBits(OffscreenCompositePicture.hDC, MaxInt(CurrentX - CurrentLeft, CurrentX - OldLeft), MaxInt(0, CurrentTop - OldTop), SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), SpriteHeight, lpSpritePixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCPAINT)
    ' Copy composite buffer to screen DC.
    Dummy = BitBlt(AnimationPicture.hDC, MinInt(OldLeft, CurrentLeft), MinInt(OldTop, CurrentTop), OffscreenCompositeWidth, OffscreenCompositeHeight, OffscreenCompositePicture.hDC, 0, 0, SRCCOPY)
    lpMaskPixelData = GlobalUnlock(SpriteDIBHandles(CurrentSpriteCel, 1))
    lpSpritePixelData = GlobalUnlock(SpriteDIBHandles(CurrentSpriteCel, 2))

    OldLeft = CurrentLeft
    OldTop = CurrentTop
    BufferPicture.Refresh
    'OffscreenCompositePicture.Refresh
    End Sub

Sub Form_Activate ()
    Dim Dummy As Integer
    Dummy = BitBlt(BufferPicture.hDC, 0, 0, bmBitmapInfo.bmiHeader.biWidth, bmBitmapInfo.bmiHeader.biHeight, AnimationPicture.hDC, CurrentLeft, CurrentTop, SRCCOPY)

    End Sub

Sub Form_Load ()
    Timer1.Enabled = False
    Forward = True
    Down = True
    CurrentLeft = 0
    CurrentTop = 0
    ReDim SpriteBitmapFiles(6)
    ReDim SpriteDIBHandles(6, 2)
    SpriteBitmapFiles(1) = App.Path & "\Moth1.DIB"
    SpriteBitmapFiles(2) = App.Path & "\Moth2.DIB"
    SpriteBitmapFiles(3) = App.Path & "\Moth3.DIB"
    SpriteBitmapFiles(4) = App.Path & "\Moth4.DIB"
    SpriteBitmapFiles(5) = App.Path & "\Moth3.DIB"
    SpriteBitmapFiles(6) = App.Path & "\Moth2.DIB"
    Screen.MousePointer = 11 ' Hourglass
    NumberOfSprites = LoadAndPrepareSprites(6)
    Screen.MousePointer = 0
    Timer1.Enabled = True
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim SpriteCounter As Integer
    Dim Counter As Integer

    For SpriteCounter = 1 To NumberOfSprites
	For Counter = 1 To 2
	    If SpriteDIBHandles(SpriteCounter, Counter) <> 0 Then
		SpriteDIBHandles(SpriteCounter, Counter) = GlobalFree(SpriteDIBHandles(SpriteCounter, Counter))
	      End If
	    Next Counter
	Next SpriteCounter

    If hBitmapPixelData <> 0 Then
	hBitmapPixelData = GlobalFree(hBitmapPixelData)
      End If
    End Sub

Sub HideBufferCheck_Click ()
    If HideBufferCheck = 1 Then
	BufferPicture.AutoRedraw = True
	BufferPicture.Visible = False
	OffscreenCompositePicture.AutoRedraw = True
	OffscreenCompositePicture.Visible = False
      Else
	BufferPicture.Visible = True
	BufferPicture.AutoRedraw = True
	OffscreenCompositePicture.Visible = True
	OffscreenCompositePicture.AutoRedraw = False
      End If
    End Sub

Function LoadAndPrepareSprites (SpritesToLoad As Integer) As Integer
    Dim SpriteCounter As Integer
    Dim MsgString As String
    Dim RetValue As Integer

    SpriteCounter = 1
    Do While SpriteCounter <= SpritesToLoad
	ReadBitmapFile SpriteBitmapFiles(SpriteCounter), bmBitmapFileHeader, bmBitmapInfo, hBitmapPixelData
	If bmBitmapInfo.bmiHeader.biBitCount <> 8 Then
	    MsgString = "File " & SpriteBitmapFiles(SpriteCounter) & " has " & Str$(bmBitmapInfo.bmiHeader.biBitCount) & " bit pixels." & Chr$(13) & Chr$(10)
	    MsgString = MsgString & "Please load only 8-bit images."
	    MsgBox MsgString, 16, "Load Error"
	    LoadAndPrepareSprites = False
	  Else
	    SpriteDIBHandles(SpriteCounter, 1) = ConvertImageToMask(bmBitmapInfo, hBitmapPixelData)
	    SpriteDIBHandles(SpriteCounter, 2) = ConvertImageToSprite(bmBitmapInfo, hBitmapPixelData)
	    SpriteCounter = SpriteCounter + 1
	  End If
	hBitmapPixelData = GlobalFree(hBitmapPixelData)
	DoEvents
	Loop
    LoadAndPrepareSprites = SpriteCounter - 1
    End Function

Sub Timer1_Timer ()
    Dim Limit As Single
    Dim SpriteWidth As Single

    SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
    CurrentSpriteCel = CurrentSpriteCel Mod NumberOfSprites + 1
    If (((CurrentLeft + SpriteWidth) >= AnimationPicture.ScaleWidth) And Forward) Then
	Forward = False
      ElseIf ((CurrentLeft <= 0) And Not Forward) Then
	Forward = True
      End If
    If Forward Then
	Limit = AnimationPicture.ScaleWidth - SpriteWidth
	CurrentLeft = MinSingle(CurrentLeft + 20, Limit)
      Else
	Limit = bmBitmapInfo.bmiHeader.biWidth
	CurrentLeft = MaxSingle(CurrentLeft - 20, 0)
      End If
    If (((CurrentTop + bmBitmapInfo.bmiHeader.biHeight) >= AnimationPicture.ScaleHeight) And Down) Or ((CurrentTop <= 0) And Not Down) Then
	Down = Not Down
      End If
    If Down Then
	Limit = AnimationPicture.ScaleHeight - bmBitmapInfo.bmiHeader.biHeight
	CurrentTop = MinSingle(CurrentTop + 7, Limit)
      Else
	CurrentTop = MaxSingle(CurrentTop - 7, 0)
      End If
    
    'AnimationPicture.Refresh
    AnimationPicture_Paint
    End Sub

