Option Explicit

Dim hOffscreenCompositeDC As Integer
Dim hOffscreenCompositeBitmap As Integer
Dim hOldOffscreenCompositeBitmap As Integer
Dim hBackgroundPixelData As Integer

Dim lpBackgroundPixelData As Long
Dim hBackgroundDC As Integer
Dim hBackgroundBitmap As Integer
Dim hOldBackgroundBitmap As Integer
Dim hBitmapPixelData As Integer

Dim bmBackgroundBitmapFileHeader As BITMAPFILEHEADER
Global bmBackgroundBitmapInfo As BITMAPINFO
Dim bmSpriteFileHeader As BITMAPFILEHEADER
Global bmSpriteInfo As BITMAPINFO

Global SpriteBitmapFiles() As String
Global SpriteDIBHandles() As Integer
Global NumberOfSpriteCels As Integer

Sub CloseSprites (ResultPicture As PictureBox)
    Dim RetValue As Integer

    RetValue = SelectPalette(ResultPicture.hDC, DEFAULT_PALETTE, False)
    RetValue = SelectObject(hOffscreenCompositeDC, hOldOffscreenCompositeBitmap)
    RetValue = SelectPalette(hOffscreenCompositeDC, DEFAULT_PALETTE, False)
    RetValue = DeleteDC(hOffscreenCompositeDC)
    RetValue = DeleteObject(hOffscreenCompositeBitmap)
    RetValue = SelectObject(hBackgroundDC, hOldBackgroundBitmap)
    RetValue = SelectPalette(hBackgroundDC, DEFAULT_PALETTE, False)
    RetValue = DeleteDC(hBackgroundDC)
    RetValue = DeleteObject(hBackgroundBitmap)
    
    If hBitmapPixelData <> 0 Then
        hBitmapPixelData = GlobalFree(hBitmapPixelData)
      End If
    If hBackgroundPixelData <> 0 Then
        hBackgroundPixelData = GlobalFree(hBackgroundPixelData)
      End If
    End Sub

Function ConvertImageToMask (bmInfo As BITMAPINFO, hBitmapPixelData As Integer) As Integer
    Dim PixelBytesToCopy As Long
    Dim hMaskPixelData As Integer
    Dim lpBitmapPixelData As Long
    Dim lpMaskPixelData As Long
    Dim MaskPixelSelector As Integer
    Dim LastLine As Integer
    Dim LineCounter As Integer
    Dim ColumnCounter As Integer
    Dim LastColumn As Integer
    Dim PaddedLineWidth As Integer
    Dim BufferString As String
    Dim MemOffset As Long
    Dim TempChar As String * 1
    Dim RetValue As Integer
    Dim ColorTableIndex As Integer

    ' Copy the original bitmap pixels to another buffer,
    ' which will become the Mask pixel data.
    PixelBytesToCopy = bmInfo.bmiHeader.biSizeImage
    hMaskPixelData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, PixelBytesToCopy)
    lpBitmapPixelData = GlobalLock(hBitmapPixelData)
    lpMaskPixelData = GlobalLock(hMaskPixelData)
    hmemcpy lpMaskPixelData, lpBitmapPixelData, PixelBytesToCopy
    lpBitmapPixelData = GlobalUnlock(hBitmapPixelData)
    lpMaskPixelData = GlobalUnlock(hMaskPixelData)

    MaskPixelSelector = GlobalHandleToSel(hMaskPixelData)
    LastLine = bmInfo.bmiHeader.biHeight - 1
    LastColumn = bmInfo.bmiHeader.biWidth
    PaddedLineWidth = ((LastColumn - 1) \ 4 + 1) * 4
    For LineCounter = 0 To LastLine
        BufferString = String$(PaddedLineWidth, Chr$(0))
        MemOffset = LineCounter * PaddedLineWidth
        RetValue = MemoryRead(MaskPixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        For ColumnCounter = 1 To LastColumn
            TempChar = Mid$(BufferString, ColumnCounter, 1)
            ColorTableIndex = Asc(TempChar)
            If (Asc(bmInfo.bmiColors(ColorTableIndex).rgbRed) <> 255) Or (Asc(bmInfo.bmiColors(ColorTableIndex).rgbBlue) <> 255) Or (Asc(bmInfo.bmiColors(ColorTableIndex).rgbGreen) <> 255) Then
                Mid$(BufferString, ColumnCounter, 1) = Chr$(0)
              Else
                Mid$(BufferString, ColumnCounter, 1) = Chr$(255)
              End If
            Next ColumnCounter
        RetValue = MemoryWrite(MaskPixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        Next LineCounter
    ConvertImageToMask = hMaskPixelData
    End Function

Function ConvertImageToSprite (bmInfo As BITMAPINFO, hBitmapPixelData As Integer) As Integer
    Dim PixelBytesToCopy As Long
    Dim hSpritePixelData As Integer
    Dim lpBitmapPixelData As Long
    Dim lpSpritePixelData As Long
    Dim SpritePixelSelector As Integer
    Dim LastLine As Integer
    Dim LineCounter As Integer
    Dim ColumnCounter As Integer
    Dim LastColumn As Integer
    Dim PaddedLineWidth As Integer
    Dim BufferString As String
    Dim MemOffset As Long
    Dim TempChar As String * 1
    Dim RetValue As Integer
    Dim ColorTableIndex As Integer

    ' Copy the original bitmap pixels to another buffer,
    ' which will become the Mask pixel data.
    PixelBytesToCopy = bmInfo.bmiHeader.biSizeImage
    hSpritePixelData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, PixelBytesToCopy)
    lpBitmapPixelData = GlobalLock(hBitmapPixelData)
    lpSpritePixelData = GlobalLock(hSpritePixelData)
    hmemcpy lpSpritePixelData, lpBitmapPixelData, PixelBytesToCopy
    lpBitmapPixelData = GlobalUnlock(hBitmapPixelData)
    lpSpritePixelData = GlobalUnlock(hSpritePixelData)

    SpritePixelSelector = GlobalHandleToSel(hSpritePixelData)
    LastLine = bmInfo.bmiHeader.biHeight - 1
    LastColumn = bmInfo.bmiHeader.biWidth
    PaddedLineWidth = ((LastColumn - 1) \ 4 + 1) * 4
    For LineCounter = 0 To LastLine
        BufferString = String$(PaddedLineWidth, Chr$(0))
        MemOffset = LineCounter * PaddedLineWidth
        RetValue = MemoryRead(SpritePixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        For ColumnCounter = 1 To LastColumn
            TempChar = Mid$(BufferString, ColumnCounter, 1)
            ColorTableIndex = Asc(TempChar)
            If (Asc(bmInfo.bmiColors(ColorTableIndex).rgbRed) = 255) And (Asc(bmInfo.bmiColors(ColorTableIndex).rgbBlue) = 255) And (Asc(bmInfo.bmiColors(ColorTableIndex).rgbGreen) = 255) Then
                Mid$(BufferString, ColumnCounter, 1) = Chr$(0)
              End If
            Next ColumnCounter
        RetValue = MemoryWrite(SpritePixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        Next LineCounter
    ConvertImageToSprite = hSpritePixelData

    End Function

Function LoadAndPrepareSprites (SpritesToLoad As Integer) As Integer
    Dim SpriteCounter As Integer
    Dim MsgString As String
    Dim RetValue As Integer
    Dim SpritePalette As LOGPALETTE

    SpriteCounter = 1
    Do While SpriteCounter <= SpritesToLoad
        ReadBitmapFile SpriteBitmapFiles(SpriteCounter), bmSpriteFileHeader, bmSpriteInfo, hBitmapPixelData
        If bmSpriteInfo.bmiHeader.biBitCount <> 8 Then
            MsgString = "File " & SpriteBitmapFiles(SpriteCounter) & " has " & Str$(bmSpriteInfo.bmiHeader.biBitCount) & " bit pixels." & Chr$(13) & Chr$(10)
            MsgString = MsgString & "Please load only 8-bit images."
            MsgBox MsgString, 16, "Load Error"
            LoadAndPrepareSprites = False
          Else
            SpriteDIBHandles(SpriteCounter, 1) = ConvertImageToMask(bmSpriteInfo, hBitmapPixelData)
            SpriteDIBHandles(SpriteCounter, 2) = ConvertImageToSprite(bmSpriteInfo, hBitmapPixelData)
            SpriteCounter = SpriteCounter + 1
          End If
        hBitmapPixelData = GlobalFree(hBitmapPixelData)
        Loop
    LoadAndPrepareSprites = SpriteCounter - 1
    End Function

Function MakeBackgroundShadow (Filename As String, ResultPicture As PictureBox, ByVal hAnimationPalette As Integer)
    Dim RetValue As Integer
    Dim SpritePalette As LOGPALETTE

    ReadBitmapFile Filename, bmBackgroundBitmapFileHeader, bmBackgroundBitmapInfo, hBackgroundPixelData
    If hBackgroundPixelData <> 0 Then
        hBackgroundDC = CreateCompatibleDC(ResultPicture.hDC)
        ConstructPaletteFromColorTable bmBackgroundBitmapInfo.bmiColors(), SpritePalette
        hAnimationPalette = CreatePalette(SpritePalette)
        RetValue = SelectPalette(hBackgroundDC, hAnimationPalette, False)
        RetValue = SelectPalette(ResultPicture.hDC, hAnimationPalette, False)
        RetValue = RealizePalette(hBackgroundDC)
        lpBackgroundPixelData = GlobalLock(hBackgroundPixelData)
        hBackgroundBitmap = CreateDIBitmapFromGlobalMem(ResultPicture.hDC, bmBackgroundBitmapInfo.bmiHeader, CBM_INIT, lpBackgroundPixelData, bmBackgroundBitmapInfo, DIB_RGB_COLORS)
        lpBackgroundPixelData = GlobalUnlock(hBackgroundPixelData)
        hOldBackgroundBitmap = SelectObject(hBackgroundDC, hBackgroundBitmap)
        MakeBackgroundShadow = hBackgroundDC
      Else
        hBackgroundDC = 0
      End If
    End Function

Sub MoveSprite (OldLeft As Integer, OldTop As Integer, NewLeft As Integer, NewTop As Integer, ByVal HorizontallyReversible As Integer, ByVal VerticallyReversible As Integer, bmBitmapInfo As BITMAPINFO, hSpritePixelData As Integer, hMaskPixelData As Integer, ResultPicture As PictureBox, hAnimationPalette As Integer)
    Dim Dummy As Integer
    Dim RetValue As Integer
    Dim SpriteWidth As Integer
    Dim SpriteHeight As Integer
    Dim CurrentX As Integer
    Dim CurrentY As Integer
    Dim OffscreenCompositeWidth As Integer
    Dim OffscreenCompositeHeight As Integer
    Dim lpMaskPixelData As Long
    Dim lpSpritePixelData As Long
    Dim CompositeXOffset As Integer
    Dim CompositeYOffset As Integer
    
    If NewLeft > OldLeft Then
        SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
        CurrentX = NewLeft
        OffscreenCompositeWidth = MinInt((SpriteWidth + NewLeft - OldLeft), (ResultPicture.ScaleWidth - OldLeft))
      Else
        If HorizontallyReversible Then
            SpriteWidth = -bmBitmapInfo.bmiHeader.biWidth
            CurrentX = NewLeft + bmBitmapInfo.bmiHeader.biWidth - 1
          Else
            SpriteWidth = bmBitmapInfo.bmiHeader.biWidth
            CurrentX = NewLeft
          End If
        OffscreenCompositeWidth = MinInt(OldLeft + Abs(SpriteWidth), (Abs(SpriteWidth) + OldLeft - NewLeft))
      End If
    If HorizontallyReversible Then
        CompositeXOffset = MaxInt(CurrentX - NewLeft, CurrentX - OldLeft)
      Else
        CompositeXOffset = MaxInt(0, NewLeft - OldLeft)
      End If
    
    If NewTop > OldTop Then
        SpriteHeight = bmBitmapInfo.bmiHeader.biHeight
        CurrentY = NewTop
        OffscreenCompositeHeight = MinInt((SpriteHeight + NewTop - OldTop), (ResultPicture.ScaleHeight - OldTop))
      Else
        If VerticallyReversible Then
            SpriteHeight = -bmBitmapInfo.bmiHeader.biHeight
            CurrentY = NewTop + bmBitmapInfo.bmiHeader.biHeight - 1
          Else
            SpriteHeight = bmBitmapInfo.bmiHeader.biHeight
            CurrentY = NewTop
          End If
        OffscreenCompositeHeight = MinInt((OldTop + Abs(SpriteHeight)), (Abs(SpriteHeight) + OldTop - NewTop))
      End If
    If VerticallyReversible Then
        CompositeYOffset = MaxInt(CurrentY - NewTop, CurrentY - OldTop)
      Else
        CompositeYOffset = MaxInt(0, NewTop - OldTop)
      End If
    Dummy = SelectPalette(hOffscreenCompositeDC, hAnimationPalette, False)
    Dummy = RealizePalette(hOffscreenCompositeDC)
    ' Copy bounding rectangle of old and new positions to offscreen composite buffer.
    Dummy = BitBlt(hOffscreenCompositeDC, 0, 0, OffscreenCompositeWidth, OffscreenCompositeHeight, hBackgroundDC, MinInt(OldLeft, NewLeft), MinInt(OldTop, NewTop), SRCCOPY)
    ' Copy Mask and Sprite to composite buffer.
    lpMaskPixelData = GlobalLock(hMaskPixelData)
    lpSpritePixelData = GlobalLock(hSpritePixelData)
    Dummy = StretchDIBits(hOffscreenCompositeDC, CompositeXOffset, CompositeYOffset, SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), Abs(SpriteHeight), lpMaskPixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCAND)
    Dummy = StretchDIBits(hOffscreenCompositeDC, CompositeXOffset, CompositeYOffset, SpriteWidth, SpriteHeight, 0, 0, Abs(SpriteWidth), Abs(SpriteHeight), lpSpritePixelData, bmBitmapInfo, DIB_RGB_COLORS, SRCPAINT)
    ' Copy composite buffer to screen DC.
    Dummy = BitBlt(ResultPicture.hDC, MinInt(OldLeft, NewLeft), MinInt(OldTop, NewTop), OffscreenCompositeWidth, OffscreenCompositeHeight, hOffscreenCompositeDC, 0, 0, SRCCOPY)
    lpMaskPixelData = GlobalUnlock(hMaskPixelData)
    lpSpritePixelData = GlobalUnlock(hSpritePixelData)
    
    OldLeft = NewLeft
    OldTop = NewTop

    End Sub

Sub OpenSprites (ResultPicture As PictureBox, hAnimationPalette As Integer)
    Dim RetValue As Integer

    hOffscreenCompositeDC = CreateCompatibleDC(ResultPicture.hDC)
    hOffscreenCompositeBitmap = CreateCompatibleBitmap(ResultPicture.hDC, ResultPicture.ScaleWidth, ResultPicture.ScaleHeight)
    RetValue = SelectPalette(hOffscreenCompositeDC, hAnimationPalette, False)
    RetValue = RealizePalette(hOffscreenCompositeDC)
    hOldOffscreenCompositeBitmap = SelectObject(hOffscreenCompositeDC, hOffscreenCompositeBitmap)

    End Sub

