VERSION 2.00
Begin Form SpriteAnimationForm 
   Caption         =   "Sprite Animation Project 4"
   ClientHeight    =   4584
   ClientLeft      =   1308
   ClientTop       =   1968
   ClientWidth     =   5664
   Height          =   5004
   Left            =   1260
   LinkTopic       =   "Form1"
   ScaleHeight     =   382
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   472
   Top             =   1596
   Width           =   5760
   Begin CheckBox FlipBox 
      Caption         =   "Flippable"
      Height          =   288
      Left            =   2556
      TabIndex        =   2
      Top             =   4092
      Width           =   1428
   End
   Begin CheckBox ReverseBox 
      Caption         =   "Reversible"
      Height          =   300
      Left            =   492
      TabIndex        =   1
      Top             =   4092
      Value           =   1  'Checked
      Width           =   1392
   End
   Begin Timer Timer1 
      Enabled         =   0   'False
      Interval        =   56
      Left            =   216
      Top             =   3348
   End
   Begin PictureBox AnimationPicture 
      Height          =   3540
      Left            =   168
      ScaleHeight     =   293
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   441
      TabIndex        =   0
      Top             =   144
      Width           =   5316
   End
End
Option Explicit

Dim Forward As Integer
Dim Down As Integer
Dim CurrentLeft As Integer
Dim CurrentTop As Integer
Dim OldLeft As Integer
Dim OldTop As Integer
Dim CurrentSpriteCel As Integer
Dim hSpritePal As Integer
Dim hBackgroundDC

Sub AnimationPicture_Paint ()
    Dim RetValue As Integer

    RetValue = SelectPalette(AnimationPicture.hDC, hSpritePal, False)
    RetValue = RealizePalette(AnimationPicture.hDC)
    RetValue = BitBlt(AnimationPicture.hDC, 0, 0, AnimationPicture.ScaleWidth, AnimationPicture.ScaleHeight, hBackgroundDC, 0, 0, SRCCOPY)
    
    End Sub

Sub Form_Load ()
    Dim RetValue As Integer

    Forward = True
    Down = True
    CurrentLeft = 0
    CurrentTop = 0
    ReDim SpriteBitmapFiles(6)
    ReDim SpriteDIBHandles(6, 2)
    SpriteBitmapFiles(1) = App.Path & "\Moth1.DIB"
    SpriteBitmapFiles(2) = App.Path & "\Moth2.DIB"
    SpriteBitmapFiles(3) = App.Path & "\Moth3.DIB"
    SpriteBitmapFiles(4) = App.Path & "\Moth4.DIB"
    SpriteBitmapFiles(5) = App.Path & "\Moth3.DIB"
    SpriteBitmapFiles(6) = App.Path & "\Moth2.DIB"
    Screen.MousePointer = 11 ' Hourglass
    NumberOfSpriteCels = LoadAndPrepareSprites(6)
    hBackgroundDC = MakeBackgroundShadow(App.Path & "\Hibisc2.BMP", AnimationPicture, hSpritePal)
    Screen.MousePointer = 0
    If hBackgroundDC <> 0 Then
	OpenSprites AnimationPicture, hSpritePal
	Timer1.Enabled = True
      Else
	MsgBox "Unable to load background image.", 16, "File Error"
	Unload SpriteAnimationForm
	End
      End If
    End Sub

Sub Form_QueryUnload (Cancel As Integer, UnloadMode As Integer)
    Timer1.Enabled = False
    CloseSprites AnimationPicture
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim RetValue As Integer
    Dim SpriteCelCounter As Integer
    Dim Counter As Integer

    For SpriteCelCounter = 1 To NumberOfSpriteCels
	For Counter = 1 To 2
	    If SpriteDIBHandles(SpriteCelCounter, Counter) <> 0 Then
		SpriteDIBHandles(SpriteCelCounter, Counter) = GlobalFree(SpriteDIBHandles(SpriteCelCounter, Counter))
	      End If
	    Next Counter
	Next SpriteCelCounter

    RetValue = DeleteObject(hSpritePal)
    End Sub

Sub Timer1_Timer ()
    Dim Limit As Single
    Dim SpriteWidth As Single

    SpriteWidth = bmSpriteInfo.bmiHeader.biWidth
    CurrentSpriteCel = CurrentSpriteCel Mod NumberOfSpriteCels + 1
    If (((CurrentLeft + SpriteWidth) >= AnimationPicture.ScaleWidth) And Forward) Then
	Forward = False
      ElseIf ((CurrentLeft <= 0) And Not Forward) Then
	Forward = True
      End If
    If Forward Then
	Limit = AnimationPicture.ScaleWidth - SpriteWidth
	CurrentLeft = MinSingle(CurrentLeft + 20, Limit)
      Else
	Limit = bmSpriteInfo.bmiHeader.biWidth
	CurrentLeft = MaxSingle(CurrentLeft - 20, 0)
      End If
    If (((CurrentTop + bmSpriteInfo.bmiHeader.biHeight) >= AnimationPicture.ScaleHeight) And Down) Or ((CurrentTop <= 0) And Not Down) Then
	Down = Not Down
      End If
    If Down Then
	Limit = AnimationPicture.ScaleHeight - bmSpriteInfo.bmiHeader.biHeight
	CurrentTop = MinSingle(CurrentTop + 7, Limit)
      Else
	CurrentTop = MaxSingle(CurrentTop - 7, 0)
      End If
    MoveSprite OldLeft, OldTop, CurrentLeft, CurrentTop, (ReverseBox.Value = 1), (FlipBox.Value = 1), bmSpriteInfo, SpriteDIBHandles(CurrentSpriteCel, 2), SpriteDIBHandles(CurrentSpriteCel, 1), AnimationPicture, hSpritePal
    End Sub

