Option Explicit

Type MIXCONFIG
    wSize As Integer
    dwFlags As Long
    wChannels As Integer
    wSamplingRate As Integer '(11=11025, 22=22050, 44=44100 Hz)
    End Type

Type MIXPLAYPARAMS
    wSize As Integer
    hMixSession As Integer
    iChannel As Integer
    lpMixWave As Long
    hWndNotify As Integer
    dwFlags As Long
    wLoops As Integer ' = &HFFFF means loop forever
    End Type

Type WAVEMIXINFO
    wSize As Integer
    Version As Integer
    Date As String * 12
    dwFormats As Long
    End Type

Type Boolean
    Byte As String * 1
    End Type

Declare Function WaveMixInit Lib "WaveMix.DLL" () As Integer
Declare Function WaveMixConfigureInit Lib "WaveMix.DLL" (lpConfig As MIXCONFIG) As Integer
Declare Function WaveMixActivate Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal fActivate As Integer) As Integer
Declare Function WaveMixOpenWave Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal szWaveFilename As String, ByVal hInst As Integer, ByVal dwFlags As Long) As Long
Declare Function WaveMixOpenChannel Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal iChannel As Integer, ByVal dwFlags As Long) As Integer
Declare Function WaveMixPlay Lib "WaveMix.DLL" (lpMixPlayParams As MIXPLAYPARAMS) As Integer
Declare Function WaveMixFlushChannel Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal iChannel As Integer, ByVal dwFlags As Long) As Integer
Declare Function WaveMixCloseChannel Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal iChannel As Integer, ByVal dwFlags As Long) As Integer
Declare Function WaveMixFreeWave Lib "WaveMix.DLL" (ByVal hMixSession As Integer, ByVal lpMixWave As Long) As Integer
Declare Function WaveMixCloseSession Lib "WaveMix.DLL" (ByVal hMixSession As Integer) As Integer
Declare Sub WaveMixPump Lib "WaveMix.DLL" ()
Declare Function WaveMixGetInfo Lib "WaveMix.DLL" (lpWaveMixInfo As WAVEMIXINFO) As Integer

' Wave Format Constants for WAVEMIXINFO
Global Const WAVE_FORMAT_1M08 = &H1   ' 11.025 kHz, Mono,   8 bit
Global Const WAVE_FORMAT_1S08 = &H2   ' 11.025 kHz, Stereo, 8 bit
Global Const WAVE_FORMAT_1M16 = &H4   ' 11.025 kHz, Mono,   16 bit
Global Const WAVE_FORMAT_1S16 = &H8   ' 11.025 kHz, Stereo, 16 bit
Global Const WAVE_FORMAT_2M08 = &H10  ' 22.05  kHz, Mono,   8 bit
Global Const WAVE_FORMAT_2S08 = &H20  ' 22.05  kHz, Stereo, 8 bit
Global Const WAVE_FORMAT_2M16 = &H40  ' 22.05  kHz, Mono,   16 bit
Global Const WAVE_FORMAT_2S16 = &H80  ' 22.05  kHz, Stereo, 16 bit
Global Const WAVE_FORMAT_4M08 = &H100 ' 44.1   kHz, Mono,   8 bit
Global Const WAVE_FORMAT_4S08 = &H200 ' 44.1   kHz, Stereo, 8 bit
Global Const WAVE_FORMAT_4M16 = &H400 ' 44.1   kHz, Mono,   16 bit
Global Const WAVE_FORMAT_4S16 = &H800 ' 44.1   kHz, Stereo, 16 bit

' Flag values for MIXPLAYPARAMS
Global Const WMIX_QUEUEWAVE = &H0
Global Const WMIX_CLEARQUEUE = &H1
Global Const WMIX_USELRUCHANNEL = &H2
Global Const WMIX_HIGHPRIORITY = &H4
Global Const WMIX_WAIT = &H8

' Flag values for MIXCONFIG
Global Const WMIX_CONFIG_CHANNELS = &H1
Global Const WMIX_CONFIG_SAMPLINGRATE = &H2


' Flag values for WaveMixOpenWave()
Global Const WMIX_FILE = &H1
Global Const WMIX_RESOURCE = &H2
Global Const WMIX_MEMORY = &H4

' Flag values for WaveMixOpenChannel()
Global Const WMIX_OPENSINGLE = 0   ' open the single channel specified by iChannel
Global Const WMIX_OPENALL = 1      ' opens all the channels, iChannel ignored
Global Const WMIX_OPENCOUNT = 2    ' open iChannel Channels (eg. if iChannel = 4 will create channels 0-3)

' Flag values for WaveMixFlushChannel() and WaveMixCloseChannel()
Global Const WMIX_ALL = &H1        ' stops sound on all the channels, iChannel ignored
Global Const WMIX_NOREMIX = &H2    ' prevents the currently submited blocks from being remixed to exclude new channel

