VERSION 2.00
Begin Form WavePlay 
   Caption         =   "Wave Play"
   ClientHeight    =   4920
   ClientLeft      =   1188
   ClientTop       =   1872
   ClientWidth     =   5040
   Height          =   5664
   Left            =   1140
   LinkTopic       =   "Form1"
   ScaleHeight     =   4920
   ScaleWidth      =   5040
   Top             =   1176
   Width           =   5136
   Begin CommonDialog FileOpenDialog 
      DialogTitle     =   "Open Wave File"
      Filename        =   "*.wav"
      Filter          =   "Wave Audio|*.wav"
      Left            =   0
      Top             =   4536
   End
   Begin PictureBox Picture1 
      Height          =   4455
      Left            =   240
      ScaleHeight     =   4428
      ScaleWidth      =   4428
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
   Begin Shape Shape1 
      FillStyle       =   0  'Solid
      Height          =   4452
      Left            =   360
      Top             =   240
      Width           =   4452
   End
   Begin Menu FileMenu 
      Caption         =   "File"
      Begin Menu DeviceCapsOption 
         Caption         =   "Get Device Capabilities"
      End
      Begin Menu OpenOption 
         Caption         =   "Open Wave File"
      End
      Begin Menu QuitOption 
         Caption         =   "Quit"
      End
   End
   Begin Menu EffectsMenu 
      Caption         =   "Effects"
      Begin Menu VolumeOption 
         Caption         =   "Change Volume"
      End
      Begin Menu EchoOption 
         Caption         =   "Add Echo"
      End
   End
   Begin Menu PlayOption 
      Caption         =   "Play"
   End
End
Option Explicit

Sub DeviceCapsOption_Click ()
    Dim Result As Integer
    Dim CapsRecord As WAVEOUTCAPS
    Dim MajorVersion As Integer
    Dim MinorVersion As Integer
    Dim ProductName As String
    Dim Counter As Integer

    Result = waveOutGetDevCaps(0, CapsRecord, Len(CapsRecord))
    If Result = 0 Then
        Picture1.Cls
        Picture1.Print "Manufacturer's Driver ID: "; CapsRecord.wMid
        Picture1.Print "Product ID: "; CapsRecord.wPid
        MajorVersion = CapsRecord.vDriverVersion \ 256
        MinorVersion = CapsRecord.vDriverVersion Mod 256
        Picture1.Print "Driver Version: "; MajorVersion; "."; MinorVersion'Str$(CapsRecord.vDriverVersion)
        ProductName = Left$(CapsRecord.szPName, InStr(CapsRecord.szPName, Chr$(0)) - 1)
        Picture1.Print "Product Name: "; ProductName
        Picture1.Print "Wave Formats Supported:"
        For Counter = 0 To 11
            If CapsRecord.dwFormats And 2 ^ Counter Then
                Picture1.Print "    "; WaveFormatStringFromConstant(2 ^ Counter)
              End If
            Next Counter
        Picture1.Print "Number of Channels: "; Str$(CapsRecord.wChannels)
        Picture1.Print "Device Functions Supported:"
        For Counter = 0 To 4
            If CapsRecord.dwSupport And 2 ^ Counter Then
                Picture1.Print "    "; WaveFunctionStringFromConstant(2 ^ Counter)
              End If
            Next Counter
      End If
    End Sub

Sub EchoOption_Click ()
    Dim Dummy As Integer

    Screen.MousePointer = 11
    PlayOption.Enabled = False
    Dummy = AddEcho(hWaveSampleData, 1000, 50)
    PlayOption.Enabled = True
    Screen.MousePointer = 0
    End Sub

Sub Form_Load ()
    PlayOption.Enabled = False
    VolumeOption.Enabled = False
    EchoOption.Enabled = False
    EffectsMenu.Enabled = False
    End Sub

Sub Form_Unload (Cancel As Integer)
    CloseWavePlay
    End Sub

Sub OpenOption_Click ()
    PlayOption.Enabled = False
    VolumeOption.Enabled = False
    EchoOption.Enabled = False
    EffectsMenu.Enabled = False
    FileOpenDialog.Action = 1
    If OpenWaveFile(FileOpenDialog.Filename) Then
        PlayOption.Enabled = True
        VolumeOption.Enabled = True
        EchoOption.Enabled = True
        EffectsMenu.Enabled = True
        Picture1.Cls
        Picture1.Print "Format: "; WaveFormatConstantFromFormat(PCMWaveFmtRecord)
        Picture1.Print "    Sample Rate: "; PCMWaveFmtRecord.wf.nSamplesPerSec; " Hz"
        Picture1.Print "    Resolution: "; PCMWaveFmtRecord.wBitsPerSample
        Picture1.Print "    Channels: "; PCMWaveFmtRecord.wf.nChannels
      End If
    End Sub

Sub PlayOption_Click ()
    Dim Dummy As Integer
    
    Dummy = WaveOut()
    End Sub

Sub QuitOption_Click ()
    Unload WavePlay
    End
    End Sub

Sub VolumeOption_Click ()
    Dim Dummy As Integer

    Screen.MousePointer = 11
    PlayOption.Enabled = False
    ChangeLevel hWaveSampleData, -50
    PlayOption.Enabled = True
    Screen.MousePointer = 0
    End Sub

